﻿/*!
 @header wikit.js
    Javscript library for WikityWidget
 @copyright 2004-2005
    Michael Robinette, ¡nkspotting [http://inkspotting.com] 
 @update Saturday; October 15, 2005
 @version 0.1
*/


/*

<!--

couple of problems here:
    1: setting the doctype makes the scrolling not work
    2: webkit can't seem to handle internal doctypes,
        it renders the last ]> for some reason
    3: The internal doctype exists so that the search input will validate.
    
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
                      "http://www.w3.org/TR/html4/loose.dtd"
    [
    <!ATTLIST input 
               incremental (0|1) "0"
               placeholder CDATA #IMPLIED
               onSearch CDATA #IMPLIED
               results CDATA #IMPLIED
               type (text | 
                     password | 
                     checkbox |
                     radio | 
                     submit | 
                     reset |
                     file | 
                     hidden | 
                     image | 
                     button | 
                     search) "text" >
    ] 
>

-->


<!-- Creative Commons Licence -->
<!-- ©2004-2005 Michael Robinette, ¡nkspotting.
<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/">
<img alt="Creative Commons Licence" border="0" 
    src="http://creativecommons.org/images/public/somerights20.gif" />
</a><br />
This work is licensed under a 
<a rel="license" href="http://creativecommons.org/licenses/by-nc-sa/2.0/">
    Creative Commons License
</a>.
-->
<!-- /Creative Commons Licence -->


<!--

<rdf:RDF xmlns="http://web.resource.org/cc/"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
<Work rdf:about="">
   <dc:title>WikityWidget</dc:title>
   <dc:date>2005</dc:date>
   <dc:description>
        A personal wiki for the Mac OS X Tiger Dashboard
   </dc:description>
   <dc:creator><Agent>
      <dc:title>Michael Robinette</dc:title>
   </Agent></dc:creator>
   <dc:rights><Agent>
      <dc:title>Michael Robinette</dc:title>
   </Agent></dc:rights>
   <dc:type rdf:resource="http://purl.org/dc/dcmitype/Interactive" />
   <dc:source rdf:resource="http://inkspotting.com/wikity/"/>
   <license rdf:resource="http://creativecommons.org/licenses/by-nc-sa/2.0/" />
</Work>

<License rdf:about="http://creativecommons.org/licenses/by-nc-sa/2.0/">
   <permits rdf:resource="http://web.resource.org/cc/Reproduction" />
   <permits rdf:resource="http://web.resource.org/cc/Distribution" />
   <requires rdf:resource="http://web.resource.org/cc/Notice" />
   <requires rdf:resource="http://web.resource.org/cc/Attribution" />
   <prohibits rdf:resource="http://web.resource.org/cc/CommercialUse" />
   <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
   <requires rdf:resource="http://web.resource.org/cc/ShareAlike" />
</License>

</rdf:RDF>

-->
*/

function max(a,b) { return (a>b) ? a : b; }

function min(a,b) { return (a<b) ? a : b; }

function abs(a)   { return (a>0) ? a : -a; }

function log(x) {alert(x);}

//gets a localized string or returns the key instead

function _l(key)
{
	try
	{
		var value = localizedStrings[key]
		if(null != value) return value;
	}
	catch(e)
	{}
	return key;
}

function truncate(str, len)
{
	if( str.length < len ) return str;


	var result = "";
	var regex = new RegExp("(\\S*\\s*)", "mg");
	var match = null;
	while((match = regex.exec(str)) && result.length < len)
	{
		if(result.length + match[0].length < len)
		{
			result += match[0];
		}
		else
		{
			result += "...";
			break;
		}
	}
	return result;
	
}

function createOnSearchHandler(handler)
{
	/*
		we can't just run the search here. the keypress handler is processed
		before the value of the input text changes. it doesn't seem to matter
		if we listen for the event during the bubbling phase or not. but if
		we wait a few milliseconds for the value of the input filed to be set,
		then it works. the drawback is that in the html we can't just say:
			onssearch = search(this.text)
		we have to say:
			onsearch = search(document.getElementById('some-id').value)
		
		this is only so that the setup function can automagically turn the
		fancy safari search type inputs into live search boxes in other 
		browsers.
		
		/ref initSearchInputsForNormalBrowsers
	*/
	return function()
	{
		var f = function(){ return eval(handler); };
		setTimeout(f, 10);
	}
}

function initSearchInputsForNormalBrowsers()
{
	var inputs = document.getElementsByTagName('input');
	if(null == inputs || 0 == inputs.length) return;
	
	for_each(inputs, function(field)
	{
		var type = field.getAttribute('type');
		if(null == type || "search" != type) return;
		
		var handler = field.getAttribute('onsearch');
		if(null == handler) return;
		
		
		if(null != field.addEventListener)
		{
			field.addEventListener('keypress', 
			                       createOnSearchHandler(handler),
			 					   false);
		}
		else if(null != field.attachEvent)
		{
			field.attachEvent('onkeydown', 
							  createOnSearchHandler(handler), 
							  false);
		}
	});
}

function replace_all( str, find, replace ) 
{ 
    if (str.length == 0)
        return str;
    var replaced = "";
    var right = str;
    var idx = right.indexOf( find );
    while ( idx >= 0 )        
    { 
        replaced += right.substring( 0, idx ) + replace;
        right = right.substring( idx + find.length );
        idx = right.indexOf( find );
    }
    replaced += right;
    return replaced;
}

function _q( str ) 
{
    return replace_all( str, "'", "''" );
}

function for_each(obj, fn) 
{
	if(null == obj) return;
    
    if(null == obj.length)
    {
        for(var o in obj)
        {
            fn(obj[o]);
        }
    }
	else if(0 != obj.length)
    {
        for(var ii = 0; ii < obj.length; ++ii)
        {
            fn(obj[ii]);
        }
    }
}

function getWikitBodyHeight() 
{
    return widgetView.height() - 55 - 50;

}

function wikit() 
{
    this.title = "";
    this.text = null;
    this.subtitle = "";
    this.created = 0;
    this.modified = 0;
	
	this.copy = function()
	{
		var w = new wikit();
		w.title = this.title;
		w.text = this.text;
		w.subtitle = this.subtitle;
		w.created = this.created;
		w.modified = this.modified;
		return w;
	}
}

function arrayIndexOf(val)
{
	for(var ii = 0; ii < this.length; ++ii)
	{
		if(this[ii] == val) 
		{
			return ii;
		}
	}
	return -1;
}

if(null == Array.prototype.indexOf)
{
	Array.prototype.indexOf = arrayIndexOf;
}

function jsDB()
{
	this.db = new Array();
	this.dbkeys = new Array();
	
	var keys = null;
	if(window.widget)
	{
		keys = widget.preferenceForKey('wikit_names');
		entries = widget.setPreferenceForKey('wikits');
		if(null != keys && null != entries)
		{
			this.dbkeys = keys.parseJSON();
			this.db = entries.parseJSON();
		}
	}
	else
	{
		keys = readCookie('wikit_names');
		if(null == keys) return;
		this.dbkeys = keys.parseJSON();
		var thisdb = this.db;
		for_each(this.dbkeys, function(key)
		{
			var w = readCookie(key);
			if(null == w) return;
			var e = w.parseJSON();
			thisdb.push(e);
		});
	}

	
	this.getWikit = function(name)
	{
		var w = new wikit();
		w.title = name;
		var nn = this.dbkeys.indexOf(name);
		
		if(-1 == nn) return w;
		
		return this.db[nn];
	}
	
	this.saveWikit = function(oldName, wikit)
	{
		var nn = this.dbkeys.indexOf(oldName)
		if(-1 == nn)
		{
			this.dbkeys.push(wikit.title);
			this.db.push(wikit.copy());
		}
		else
		{
			this.dbkeys[nn] = wikit.title;
			this.db[nn] = wikit.copy();
		}
		
		if(window.widget)
		{
			widget.setPreferenceForKey('wikit_names', 	
										this.dbkeys.toJSONString());
			widget.setPreferenceForKey('wikits',
										this.db.toJSONString());
		}
		else
		{
			eraseCookie('wikit_names');
			createCookie('wikit_names', this.dbkeys.toJSONString(), 365*20);
			createCookie(wikit.title, wikit.toJSONString(), 365*20);
		}
	}
	
	this.searchWiki = function(searchString, searchHandler)
	{
		var regex = new RegExp(searchString, 'mgi');
		for_each(this.db, function(wikit)
		{
			if("*" == searchString)
			{
				searchHandler.addSearchResult(wikit);
			}
			else if(regex.exec(wikit.title))
			{
				searchHandler.addSearchResult(wikit);
			}
			else if(regex.exec(wikit.text))
			{
				searchHandler.addSearchResult(wikit);
			}
		})
	}
	
	this.wikitExists = function(title)
	{
		return (-1 != this.dbkeys.indexOf(title));
	}
	
	this.deleteWikit = function(title)
	{
		
	}
}

function inkDbGetWikit( name ) 
{
	if(!window.InkDatabase)
	{
		return this.jsdb.getWikit(name);
	}
	
    var w = new wikit();
    w.title = name;
    var row = InkDatabase.selectRowWithSql( 
                    "select * from wiki where lower(title) = lower('" +
                    _q(name) + "');" );
    if( null == row )
    {
        return w;
    }
    var rowText = row.objectForKey( "text" );
    if( rowText != "" )
        w.text = rowText;
		
	w.created = row.objectForKey("created");
	w.modified = row.objectForKey("modified");
	w.title = row.objectForKey("title");
    return w;
}

function inkDbSaveWikit( oldName, wikit ) 
{
	if(!window.InkDatabase)
	{
		this.jsdb.saveWikit(oldName, wikit);
		return;
	}
    var row;
    row = InkDatabase.selectRowWithSql( 
                "select count(*) from wiki where title = '" +
                _q(oldName) + "';" );
    if( null == row )
    {
        return;
    }
    var count = row.objectAtIndex( 0 );

    if( 0 == count )
    {
        var sql;
        sql = "insert into wiki( created, modified, title, text ) values( " +
                    "(select datetime('now')), (select datetime('now'))" +
                    ", '" + _q(wikit.title) + "', '" + 
                    _q(wikit.text) + "' );";
        var err = InkDatabase.exec( sql );
        if( null != err )
        {
            alert( "insert into wiki failed: " + err.description );
        }
    }
    else
    {
        var sql = "update wiki set modified = (select datetime('now')), " +
                    "title = '" + _q(wikit.title) + "', " +
                    "text = '" + _q(wikit.text) + "' where title = '" +
                            _q(oldName) + "';";
        var err = InkDatabase.exec( sql );
        if( null != err )
        {
            log( "update wiki failed: " + err.description );
        }
    }

}

function inkDbSearchWiki( searchString, searchHandler ) 
{
	if(!window.InkDatabase)
	{
		this.jsdb.searchWiki(searchString, searchHandler);
		return;
	}
	
    var query = InkDatabase.queryForSql( 
        "select title, text, created, modified from wiki " +
        "where lower(title) glob lower('*" + 
        _q(searchString) + "*') or lower(text) glob lower('*" + 
        _q(searchString) + "*');" );
    var row;
    var foundOne = false;
    while( null != (row = query.next()) )
    {
        foundOne = true;
        var w = new wikit();
        w.title = row.objectAtIndex( 0 );
        w.text = row.objectAtIndex( 1 );
        w.created = row.objectAtIndex( 2 );
        w.modified = row.objectAtIndex( 3 );
        searchHandler.addSearchResult( w );
    }
    
    if( !foundOne )
    {
        searchHandler.nothingFound();
    }

    query.dispose();
}

function inkDbWikitExists( title ) 
{
	if(!window.InkDatabase)
	{
		return this.jsdb.wikitExists(title);
	}
    var row = InkDatabase.selectRowWithSql( 
                    "select count(*) from wiki where lower(title) = lower('" +
                    _q(title) + "');");
    return ( 0 != row.objectAtIndex( 0 ) );
}

function inkDbDeleteWikit( title ) 
{	
	if(!window.InkDatabase)
	{
		this.jsdb.deleteWikit(title);
		return;
	}
	
    return InkDatabase.exec( "delete from wiki where lower(title) = lower('" +
                    _q(title) + "');");
}

function setup_table(name, schema, creation_action) 
{
	if(window.InkDatabase)
	{
    	if(InkDatabase.tableExists(name))
	    {
	        return true;
	    }
    
	    var err = InkDatabase.exec(schema);
	    if(err)
	    {
	        log("create table failed:" + err.description());
	        return false;
	    }
	}

    if(creation_action) creation_action();

    return true;
}

function inkWikiInit() 
{   
    var wiki_schema = "create table wiki( " +
                "created timestamp not null, modified timestamp not null, " +
                "title text not null, text not null, primary key( title ) );";
    
    var self = this;
    var action = function()
    {
        self.insertDefaultWikits();
    }
    
    if( !setup_table("wiki", wiki_schema, action) )
    {
        log("setup wiki failed");
        return;
    }

    
    var version_schema = "create table widget_version(" +
                                "created timestamp not null, " +
                                "version text not null, " +
                                " primary key(version));";
    if( !setup_table("widget_version", version_schema, null) )
    {
        log("setup wiki failed");
        return;
    }
    
    this.handle_upgrades();
    
    this.wikiInitialized = true;
    
}

function inkWikiInsertDefaultWikits() 
{
    
    var w = new wikit();
	
    w.title = _l('HelpAndIntroTitle');   
    w.text = _l('HelpAndIntroText');
    this.saveWikit(w.title, w);
        
    w.title = _l('WikityWidgetTitle');   
    w.text = _l('WikityWidgetText')
    this.saveWikit(w.title, w);
        
    w.title = _l('TigerDashboardTitle');
    w.text = _l('TigerDashboardText');
    this.saveWikit(w.title, w);
        
	w.title = _l('WikityLinksTitle');
	w.text = _l('WikityLinksText');
    this.saveWikit(w.title, w);
        
    w.title = _l('MichaelRobinetteTitle');
    w.text = _l('MichaelRobinetteText');
    this.saveWikit(w.title, w);
}

function inkWiki() 
{
    this.this_version = "1.5.0";
    this.last_version = "0.0.0";
    this.upgrade_first_run = false;
	this.jsdb = null;
    if( !window.InkDatabase )
    {
        //log( "missing InkDatabase plugin" );
		this.jsdb = new jsDB();
    }
    
    inkWiki.prototype.getWikit = inkDbGetWikit;
    inkWiki.prototype.saveWikit = inkDbSaveWikit;
    inkWiki.prototype.deleteWikit = inkDbDeleteWikit;
    inkWiki.prototype.searchWiki = inkDbSearchWiki;
    inkWiki.prototype.wikitExists = inkDbWikitExists;
    
    inkWiki.prototype.init = inkWikiInit;
    inkWiki.prototype.insertDefaultWikits = inkWikiInsertDefaultWikits;

    inkWiki.prototype.insert_release_notes = function()
    {
        var w = new wikit();
        w.title = "Release Notes " + this.this_version;
        w.text = "• fixed: long urls would not wrap correctly.\n\n" +
                 "• new: Scroll wheel support for 10.4.1+\n\n" +
                 "• new: Widget is now resizable\n\n" + 
                 "• new: Keyboard shortcuts: " +
                    "<ul style='list-style:none;'>" +
                    "<li>⌘h : home</li>" +
                    "<li>⌘n : new wikit</li>" +
                    "<li>⌘e : edit wikit</li>" +
                    "<li>⌘s : save wikit</li>" +
                    "<li>⌘esc : cancel edit</li>" +
                    "<li>⌘delete : delete wikit</li>" +
                    "<li>⌘f : find</li>" +
                    "<li>⌘+ : make text bigger</li>" +
                    "<li>⌘- : make text smaller</li>" +
                    "<li>⌘[ : go back</li>" +
                    "<li>⌘] : go forward</li>" +
                    "</ul>" +
                 "• new: Confirmation 'sheet' for deleting.\n\n" +
                 "• new: Confirmation 'sheet' for canceling edits.\n\n" +
                 "• new: Typography (Thanks Alex and TypeCast).\n\n" +
                 "• new: Allow inline HTML\n\n" +
                 "• new: Allow text selection\n\n" +
                 "• new: Disable buttons when appropriate\n\n" +
                 "• new: Forward/Back navigation via keyboard shortcuts\n\n" +
				 "• new: use [[ ]] notation to create [[Wikity Links]]";
                 
        this.saveWikit(w.title, w);
    }

    inkWiki.prototype.handle_upgrades = function()
    {
		if(!window.InkDatabase) return;
		
        var sql = "select version from " +
                        "widget_version " +
                  "order by created desc limit 1;";
        var row = InkDatabase.selectRowWithSql(sql);
        if(row)
            this.last_version = row.objectAtIndex(0);
        
        InkDatabase.exec("insert or ignore into " +
                            "widget_version(created, version) " +
                         "values((select datetime('now')), '" + 
                                    this.this_version + "');");
        
        if(this.last_version < this.this_version)
        {
            this.upgrade_first_run = true;
            this.insert_release_notes();
        }
        
    }

}

function wikiDisplayNothingFound() 
{
    var displayDiv = this.rootElement.getElementById( "search-results" );
    if( !displayDiv )
    {
        log( "displayDiv is null" );
        return;
    }

    var searchLists = displayDiv.getElementsByTagName( "ul" );
    var searchList = null;
    if( !searchLists || 0 == searchLists.length )
    {
        searchList = document.createElement( "ul" );
        displayDiv.appendChild( searchList );
    }
    else
    {
        searchList = searchLists.item( 0 );
    }
    if( !searchList )
    {
        log( "searchList is null" );
        return;
    }
    var searchListItem = document.createElement("li");
    searchListItem.appendChild(document.createTextNode("Nothing found"));
    searchList.appendChild( searchListItem );
    this.wikitScroller.setDivToScroll( searchList );
}

function wikiDisplayAddSearchResult( wiki ) 
{
    var displayDiv = this.rootElement.getElementById( "search-results" );
    if( !displayDiv )
    {
        log( "displayDiv is null" );
        return;
    }

    var searchLists = displayDiv.getElementsByTagName( "ul" );
    var searchList = null;
    if( !searchLists || 0 == searchLists.length )
    {
        searchList = document.createElement( "ul" );
        displayDiv.appendChild( searchList );
    }
    else
    {
        searchList = searchLists.item( 0 );
    }
    if( !searchList )
    {
        log( "searchList is null" );
        return;
    }
    var searchListItem = document.createElement("li");
    var link =  this.wikitFormatter.createWikiLink(wiki.title, wiki.title);
	
	var text = wiki.text;
	var tip = truncate(wiki.text, 80);
	
	link.setAttribute("title", tip);
    searchListItem.appendChild(link);
    searchList.appendChild( searchListItem );
    this.wikitScroller.setDivToScroll( searchList );
}

function wikiDisplayClearSearches() 
{
    var displayDiv = this.rootElement.getElementById( "search-results" );
    if( !displayDiv )
    {
        log( "displayDiv is null" );
        return;
    }
    
    var searchLists = displayDiv.getElementsByTagName( "ul" );
    var searchList = null;
    if( searchLists && 0 != searchLists.length )
    {
        displayDiv.removeChild( searchLists.item(0) );
    }

    this.wikitScroller.setDivToScroll( null );
}

function wikiDisplayInitWithFormatter( formatter ) 
{
    this.wikitFormatter = formatter;
    var scrollThumb = document.getElementById( "scroll-thumb" ); 
    var scrollTrack = document.getElementById("scroll-track");
    this.wikitScroller.init(25, widgetView.height() - 55 - 40);
}

function wikiDisplayShowWikit( title ) 
{
    var display = document.getElementById( "wikit-area" );
    if( !display )
    {
        log( "wikit-area is null" );
        return;
    }
    while( display.childNodes.length > 0 )
        display.removeChild( display.childNodes[ 0 ] );
    var w = wiki.getWikit( title ); 
    var div = null;   
    div = this.wikitFormatter.formatWikitReadOnly( w );
    
    if( !div )
    {
        log( "wikit is null" );
        return;
    }
    display.appendChild( div );
    this.showWikits();
    div = document.getElementById( "body" + title );
    this.wikitScroller.setDivToScroll( div );    
	dom('browse-toolbar').show();
	dom('edit-toolbar').hide();
    if( window.widget )
    {
        widget.setPreferenceForKey(title, 
								   widget.identifier + "-currentWikit");
    }
    
    function create_wikity_history_entry(d, t)
    {
        return function()
        {
            return d.showWikit(t);
        }
    }
    wikity_history.add(title, create_wikity_history_entry(this, title));
}

function wikiDisplayEditWikit( title ) 
{
    var display = document.getElementById( "wikit-area" );
    if( !display )
    {
        log( "wikit-area is null" );
        return;
    }
    while( display.childNodes.length > 0 )
        display.removeChild( display.childNodes[ 0 ] );
    var w = wiki.getWikit( title ); 
    var div = wikiController.wikitFormatter.formatWikitEditor( w );  
    
    if( !div )
    {
        log( "wikit is null" );
        return;
    }
    display.appendChild( div );
    this.wikitScroller.setDivToScroll( null );
    wikiController.showWikits();
	dom('browse-toolbar').hide();
	dom('edit-toolbar').show();

    var editor = document.getElementById("editor-body-" + title);
    if(editor) editor.focus();
}


function wikiDisplayShowSearches(title) 
{
    this.hideWikits();
    var searchDiv = this.rootElement.getElementById( "search-results" );
    if( !searchDiv )
    {
        log("searchDiv is nill");
        return;
    }
    var titleDiv = document.getElementById("search-title");
    if(titleDiv)
    {
        titleDiv.removeChild( titleDiv.childNodes[0] );
        titleDiv.appendChild( document.createTextNode(title) );
    }
    dom('search-results').show();

}

function wikiDisplayHideSearches() 
{
	dom('search-results').hide();
}

function wikiDisplayShowWikits() 
{
    this.hideSearches();
    dom('wikit-area').show();
}

function wikiDisplayHideWikits() 
{
	dom('wikit-area').hide();
}

function wikiDisplayStartScrolling( scrollUp ) 
{
    this.wikitScroller.startScrolling( scrollUp );
}

function wikiDisplayStopScrolling() 
{
    this.wikitScroller.stopScrolling();
}

function wikiDisplayIsSearching() 
{
    var visibility = dom("search-results").style.visibility;
    return  visibility == "visible";
}

function wikiDisplay() 
{
    this.rootElement = document;
    this.wikitFormatter = null;
    this.wikitScroller = new scroller();
    this.wikitScroller.height = 175;
    
    wikiDisplay.prototype.initWithFormatter = wikiDisplayInitWithFormatter;
    wikiDisplay.prototype.addSearchResult = wikiDisplayAddSearchResult;
    wikiDisplay.prototype.nothingFound = wikiDisplayNothingFound;
    wikiDisplay.prototype.clearSearches = wikiDisplayClearSearches;
    wikiDisplay.prototype.showSearches = wikiDisplayShowSearches;
    wikiDisplay.prototype.hideSearches = wikiDisplayHideSearches;
    wikiDisplay.prototype.showWikits = wikiDisplayShowWikits;
    wikiDisplay.prototype.hideWikits = wikiDisplayHideWikits;
    wikiDisplay.prototype.showWikit = wikiDisplayShowWikit;
    wikiDisplay.prototype.editWikit = wikiDisplayEditWikit;
    wikiDisplay.prototype.isSearching = wikiDisplayIsSearching;
    wikiDisplay.prototype.startScrolling = wikiDisplayStartScrolling;
    wikiDisplay.prototype.stopScrolling = wikiDisplayStopScrolling;
    this.scroll_tracker = new ScrollThumbTracker(this.wikitScroller);

    wikiDisplay.prototype.isEditing = function()
    {
        if(this.isSearching()) return false;
        
        var title = getCurrentWikitTitle();
        if(null == title) return false;
        var toolbar = dom( "edit-toolbar" ); 
        return ("visible" == toolbar.style.visibility);
        
    }
        
    wikiDisplay.prototype.get_font_size = function()
    {
        var body;
        body = document.getElementById("front");
        var style = document.defaultView.getComputedStyle(body,'');
        var size = style.getPropertyValue('font-size');
        return parseInt(size);
    }
    
    wikiDisplay.prototype.set_font_size = function(size_in_px)
    {
        var body;
        body = document.getElementById("front");
        body.style.fontSize = size_in_px + "px";
        this.wikitScroller.setDivToScroll( this.wikitScroller.divToScroll );
        if(window.widget)
        {
            widget.setPreferenceForKey(size_in_px, 
                                       widget.identifier + "-font_size");
        }
    }
    
    wikiDisplay.prototype.make_text_larger = function()
    {
        
        this.set_font_size(this.get_font_size() + 1);
    
    }
    
    wikiDisplay.prototype.make_text_smaller = function()
    {
        this.set_font_size(this.get_font_size() - 1);
    }
    
}

function getOuterHTML(node)
{
	if(null != node.outerHTML) return node.outerHTML;
	var html = '<';
	html += node.nodeName;

	for (var a = 0; a < node.attributes.length; a++)
	{
		html += ' ' + node.attributes[a].nodeName.toUpperCase() +
				'="' + node.attributes[a].nodeValue + '"';
	}
	html += '>';

	html += node.innerHTML;
	html += '<\/' + node.nodeName + '>';
	return html;
}

function wikiFormatterCreateWikiLink( title ) 
{	
    var link = document.createElement("a");
    link.onclick = function()
	{
		wikiController.showWikit( title );
		toolbar.enable_all();
	};
    link.setAttribute("href","#");
    link.setAttribute("title", title );
    link.appendChild( document.createTextNode( title ) );

    if( wiki.wikitExists( title ) )
        link.setAttribute("class", "existing-wikit");
    else
        link.setAttribute("class", "empty-wikit");
    
	return link;

}

function wikiFormatterCreateExternalLink( href ) 
{
    var link = document.createElement("a");
    if( window.widget )
	{
       	link.setAttribute("href", href);
       	link.onclick = function()
		{
			if(window.widget) widget.openURL( this.href );
		};
	}
    else
    {
        link.setAttribute("href", href);
    }
    link.setAttribute("title", "external link: " + href);
    link.appendChild( document.createTextNode( href ) );
    return link;
}

function addWikityClickHandlers(wikit_div)
{
	// what happens is that when we do the outerHTML/innerHTML thing, the
    // onclick handlers get lost, so we have to go back through all the links
    // to re-add the handlers.
    var links = wikit_div.getElementsByTagName("a");
    for_each(links, function(link)
    {
        var linkClass = link.getAttribute("class");
        if( linkClass == "existing-wikit" ||
            linkClass == "empty-wikit" )
		{
            link.onclick = function()
			{
				wikiController.showWikit( link.title );
				toolbar.enable_all();
			};
		}
        else
		{
            link.onclick = function()
			{
				if(window.widget) widget.openURL( link.href );
			};
		}
    });
}

function wikityRegex()
{
	var url_schemes = "http|https|mailto|ftp|feed|itms";
	var camel_link = "([A-Z]+[a-z]+[A-Z]\\w*)";
	var bracket_link = "(\\[\\[(\\S.*?)\\]\\])";
    var external_link = "((?:" + url_schemes + "):\\S*)";
	var html_href = "((?:href=\")(?:" + url_schemes + "):\\S*)";
	//var html_href = "((href\\s*=\\s*)(?:" + url_schemes + "):\\S*)";
    var new_line = "(\\n)";
    var regex = new RegExp(camel_link 	+ "|" +
						   new_line 	+ "|" +
						   bracket_link + "|" +
						   html_href  	+ "|" +
						   external_link,
						   "mg");
	return regex;
}

function wikiFormatterWikifyText( t ) 
{
	/*
	markdown = true;
	var o;
	o = widget.system('/Users/michael/Desktop/Markdown.pl --html4tags', end_markdown);
	o.write(t);
	o.close();
	var text = o.outputString;
	log(o.errorString);
	*/
	var text = t;
	var regex = wikityRegex();

    var last_match_pos = 0;

    var wikit_div = document.createElement( "div" );

    // we have to do this as innerHTML/outerHTML because otherwise we lose 
    // inline html. document.createTextNode converts <> to &lt; and &gt;
    var html = "";
    do 
    {
        var match = regex.exec(text);
        if(!match)
        {
            html += text.substring(last_match_pos);
            continue;
        }

        if(match.index > last_match_pos)
        {
            html += text.substring(last_match_pos,match.index);
        }
        last_match_pos = regex.lastIndex;
        if(match[1] != null)
        {
			html += getOuterHTML(this.createWikiLink(match[0]));
        }
        else if(match[6] != null)
        {
            html += getOuterHTML(this.createExternalLink(match[0]));
        }
        else if(match[2] != null)
        {
            html += "<br/>";
        }
    	else if(match[3] != null)
		{
			html += getOuterHTML(this.createWikiLink(match[4]));
		}
		else
		{
			// catch all matches that we wanted to print as is
			// but couldn't exclude from the matches that we did
			// want to format
			html += text.substring(last_match_pos, match.index);
		}

    } while(match != null);

    wikit_div.innerHTML = html;

    addWikityClickHandlers(wikit_div);

    return wikit_div;
	
}

function createWikitDiv( w ) 
{
    var div = document.createElement( "div" );
    div.setAttribute( "class", "wikit" );
    div.setAttribute("id","wikit-" + w.title);
    div.title = w.subtitle;

    
    return(div);
}

function wikitFormatterReadOnly( w ) 
{
    var div = createWikitDiv( w );
    var titleDiv = document.createElement( "div" );
    div.appendChild( titleDiv );
    titleDiv.setAttribute( "class", "title" );
    titleDiv.appendChild( document.createTextNode( w.title ) );
    titleDiv.setAttribute("id","title" + w.title);
	titleDiv.setAttribute("title", 
						  _l('CreatedOnPrefix') + w.created +
						  "\n" + _l('LastModifiedPrefix') + w.modified);
    div.ondblclick = function()
	{ 
		if(document.selection)
        	document.selection.empty();
		wikiController.editWikit(w.title); 
	};
    var body = document.createElement( "div" );
    body.setAttribute( "class", "body" );
    body.setAttribute( "id", "body" + w.title );
    if( null == w.text )
    {
        body.style.fontStyle = "italic";
        var newWikitText;
        newWikitText = w.title + _l('NonexistingWikitPlaceholderText');
        body.appendChild( this.wikifyText(newWikitText) );
    }
    else
    {
        body.appendChild( this.wikifyText( w.text ) );
    }
    div.appendChild( body );
    return div;
}

function wikitFormatterEditor( w ) 
{
    //var div = createWikitDiv( w );
    var div = document.createElement( "div" );
    div.setAttribute("id","wikit-" + w.title);
    div.title = w.subtitle;
    var editor = document.createElement(  "div" );
    editor.setAttribute( "class", "editor" );
    editor.setAttribute("id","editor" + w.title);
    var title = document.createElement( "div" );
    editor.appendChild( title );
    var titleInput = document.createElement( "input" );
    title.appendChild( titleInput );
    titleInput.setAttribute("id","editor-title-" + w.title);
    titleInput.setAttribute("type","text");
    titleInput.value = w.title;
    var body = document.createElement( "div" );
    editor.appendChild( body );
    var bodyInput = document.createElement( "textarea" );
    body.appendChild( bodyInput );
   
    
    bodyInput.setAttribute("id","editor-body-" + w.title);
    bodyInput.style.height = getWikitBodyHeight() + "px";
    if( null == w.text )
        bodyInput.value = _l('DefaultWikitInputPrefix') + 
						  w.title + 
						  _l('DefaultWikitInputPostfix');
    else
        bodyInput.value = w.text;
		
    div.appendChild( editor );
    return div;
}

function wikitFormatterInit() 
{
}

function wikitFormatter() 
{
    this.init = wikitFormatterInit;
    this.wikifyText = wikiFormatterWikifyText;
    this.formatWikitReadOnly = wikitFormatterReadOnly;
    this.formatWikitEditor = wikitFormatterEditor;
    this.createWikiLink = wikiFormatterCreateWikiLink;
    this.createExternalLink = wikiFormatterCreateExternalLink;
}

var widgetView = null;
var wiki = null;
var wikiController = null;
function main() 
{
    
    widgetView = dom('front');
    wiki = new inkWiki();
    wiki.init();
    
    var formatter = new wikitFormatter();
    formatter.init();
    
    wikiController = new wikiDisplay();
    wikiController.initWithFormatter( formatter );
    
    var prefs = new Prefs(kDomainWidgetInstance);
    var width = prefs.get('width');
    var height = prefs.get('height');
    if(!width || 0 == width)
    {
        width = 480;
    }

	if(!height || 0 == height)
	{
		height = 270;
	}

	var vs = new ViewResizer();
    vs.resize(width, height);

    var startWikit = "";
    if( window.widget )
    {
        var id = widget.identifier;
        startWikit = widget.preferenceForKey(id + "-currentWikit");
    }
    if( !startWikit || startWikit == "" )
        startWikit = _l('HelpAndIntroTitle');
        
    if(wiki.upgrade_first_run)
    {
        startWikit = "Release Notes " + wiki.this_version;
    }

    wikiController.showWikit( startWikit );
    if(window.widget)
    {
        var size = widget.preferenceForKey(widget.identifier + "-font_size");
        if(size)
        {
            wikiController.set_font_size(size);
        }
    }
    
    toolbar.scan_for_buttons();
	initSearchInputsForNormalBrowsers();
}

function create_wiki_searcher(searchString) 
{

    return function()
    {
        wikiController.clearSearches();
        wikiController.showSearches(_l('SearchHeaderPrefix') + searchString);
        if( searchString != "" )
            wiki.searchWiki( searchString, wikiController );
		dom('browse-toolbar').show();
		dom('edit-toolbar').hide();
        toolbar.button_with_id("browse-delete").disable();
        toolbar.button_with_id("browse-edit").disable();
    }

}

function wiki_search(searchString) 
{
    if(wikiController.isEditing())
    {
        return wikiCancel(create_wiki_searcher(searchString));
    }
    //handle search [x] when search is not active
    if(searchString == "" && !wikiController.isSearching())
        return;
    
    create_wiki_searcher(searchString)();
}

function getCurrentWikitTitle() 
{
    var display = document.getElementById( "wikit-area" );
    if( !display )
    {
        log( "wikit-area is null" );
        return null;
    }
    if( display.style.visibility == "hidden" )
    {
        log( "no current wikit" );
        return null;
    }
    var wikitDiv = display.firstChild;
    if(wikitDiv.id.substr(0,6) != "wikit-")
    {
        log( "firstChild is not a wikit" );
        return null;
    }
    return wikitDiv.id.substr(6);
}

function wikiBack() 
{
    log( "wikiBack not implemented yet" );
}

function wikiForward() 
{
    log( "wikiForward not implemented yet" );
}

function wikiNew() 
{
    var unusedTitle = "NewWikit";
    var counter = 0;
    while( wiki.wikitExists( unusedTitle ) )
    {
        unusedTitle = "NewWikit" + (++counter);
    }
    wikiController.editWikit( unusedTitle );
    toolbar.enable_all();
}

function showAllWikits() 
{
    wikiController.clearSearches();
    wikiController.showSearches(_l('AllWikitsHeader'));
    wiki.searchWiki( "*", wikiController );
	dom('browse-toolbar').show();
	dom('edit-toolbar').hide();
    toolbar.button_with_id("browse-delete").disable();
    toolbar.button_with_id("browse-edit").disable();
    toolbar.button_with_id("browse-home").enable();
    toolbar.button_with_id("browse-new").enable();
}

function wikiHome() 
{
    if(wikiController.isEditing())
        wikiCancel(showAllWikits);
    else
        showAllWikits();
}

function wikiSave() 
{
    
    var title = getCurrentWikitTitle();
    
    if( null == title )    
    {
        log("current wikit is null");
        return;
    }
    
    var newWikit = new wikit();
    newWikit.title = dom("editor-title-" + title).div.value;
    newWikit.text = dom("editor-body-" + title).div.value;
    wiki.saveWikit( title, newWikit );
    wikiController.showWikit( newWikit.title );
    toolbar.enable_all();
    
}

function wikiDeleteForReal(name) 
{
    if( null == name )
    
    {
        alert("current wikit is null");
        return;
    }
    
    if( wiki.wikitExists( name ) )
        wiki.deleteWikit( name );
        
}

function wikiDelete() 
{
    toolbar.disable_all();
    var confirm = new Sheet("confirm-delete", 
                            _l('DeleteWarningMessage') );
                            
    function create_wikit_deleter(sheet, name)
    {
        return function()
        {
            sheet.close();
            wikiDeleteForReal(name);
            wikiHome();
        }
    }
    
    function delete_sheet_canceled(sheet)
    {
        return function()
        {
            sheet.close();
            toolbar.enable_all();
        }
    }

    confirm.add_button(_l('DeleteButton'), 
                    create_wikit_deleter(confirm, getCurrentWikitTitle()),
                    13);
    confirm.add_button(_l('CancelButton'), 
					delete_sheet_canceled(confirm), 27);
    confirm.show();
}

function wikiEdit() 
{
    var title = getCurrentWikitTitle();
    
    if( null == title )    
    {
        log("current wikit is null");
        return;
    }
    
    wikiController.editWikit( title );
    toolbar.enable_all();
}

function wikiCancel(action) 
{
    var title = getCurrentWikitTitle();
    
    if( null == title )
    {
        log("current wikit is null");
        return;
    }
    
    toolbar.disable_all();
    var editor = new DOMView('editor-body-' + title);
    editor.disable();
    
    var editorTitle = new DOMView('editor-title-' + title);
    editorTitle.disable();

    var confirm = new Sheet("confirm-cancel",
                            _l('CancelSaveWarningMessage'));

    function create_edit_canceller(sheet, name)
    {
        return function()
        {
            sheet.close();
            toolbar.enable_all();
            if(null == action)
            {
                wikiController.showWikit( name );
            }
            else
            {
                action();
            }
        }
    }

    function cancel_sheet_canceled(sheet)
    {
        return function()
        {
            sheet.close();
            toolbar.enable_all();
            /*
            var editor = document.getElementById("editor-body-" + title);
            editor.disabled = false;
            */
            editor.enable();
            editorTitle.enable();
        }
    }
    
    function create_edit_saver(sheet, name)
    {
        return function()
        {
            sheet.close();
            wikiSave();
            toolbar.enable_all();
            if(null == action)
            {
                wikiController.showWikit( name );
            }
            else
            {
                action();
            }
            
        }
    }
    
    confirm.add_button(_l('SaveButton'), 
                    create_edit_saver(confirm, getCurrentWikitTitle()),
                    13);
    confirm.add_button(_l('DiscardButton'), 
                    create_edit_canceller(confirm, getCurrentWikitTitle()),
                    "");
    confirm.add_button(_l('CancelButton'), 
					cancel_sheet_canceled(confirm), 27);
    confirm.show();
    
}

function scrollerInit( t, h ) 
{
    
    var thumb = document.createElement('div');
    thumb.setAttribute('class', 'scroll-thumb');
    thumb.onmousedown = start_tracking_scroll;
    this.scrollThumb = widgetView.add_subview(new View(thumb), "thumb");
    
    var track = document.createElement('div');
    track.setAttribute('class', 'scroll-track');
    track.onmousedown = scroll_page_click;
    this.scroll_track = widgetView.add_subview(new View(track), "track");
    document.addEventListener("mousewheel", this.wheel_scroller(), true);
    
    this.clipTop = t;
    this.clipHeight = h;
}

function scrollerSetDivToScroll( div ) 
{
    this.divToScroll = div;
    if( null == this.divToScroll )
    {
        this.scrollThumb.hide();
        this.scroll_track.hide();
        return;
    }
    
    var v = new View(this.divToScroll);
    this.divToScroll.style.position = "absolute";
    v.set_top(this.clipTop);
    this.scrollPos = 0;
    
    v.clip(0, widgetView.width(), this.clipHeight, 0);

    if ( this.clipHeight >= this.divToScroll.scrollHeight ) 
    {
        this.max_pos = 0;
        this.scrollThumb.hide();
        this.scroll_track.hide();
        v.set_width(widgetView.width() - 
                    widgetView.margin("right") -
                    widgetView.margin("left")  -
                    40);
    } 
    else 
    {
        v.set_width(widgetView.width() - 
                    widgetView.margin("right") -
                    widgetView.margin("left") - 
                    this.scroll_track.width() -
                    45);
        this.scrollThumb.show();
        this.scroll_track.show();
     
        var h2 = this.divToScroll.scrollHeight;
        var h3 = this.clipHeight;
        var pages = h2/h3;
        var maxHeight = this.clipHeight - 15;
        var thumbHeight = max(maxHeight/pages, 25);
        
        this.scroll_per_pixel = (h2 - h3)/(this.clipHeight - thumbHeight);
        //ffox this.scrollThumb.div.style.height = thumbHeight - 5;
		this.scrollThumb.set_height(thumbHeight - 5);
        
        var top = 80;
        this.scrollThumb.set_top(top);
        this.scrollTop = top;
        this.max_pos = this.divToScroll.scrollHeight - this.clipHeight;
        this.min_pos = 0;
        this.max_top = this.clipHeight + top - thumbHeight;
        this.scroll_track.set_top(top);
        this.scroll_track.set_height(this.max_top + thumbHeight - top - 5);
    }
}

function scrollerScrollTo(offset) 
{
    //if(this.max_pos = 0) return;
    if(!this.divToScroll) return;
    var n = 0;
    if(offset < 0)
        n = Math.floor(offset*this.scroll_per_pixel);
    else
        n = Math.ceil(offset*this.scroll_per_pixel);
    if( offset < 0 )
    {
        this.scrollPos = max(this.min_pos, this.scrollPos + n);
        this.scrollTop = max(80, this.scrollTop + offset );
    }
    else
    {
        this.scrollPos = min(this.max_pos, this.scrollPos + n);
        this.scrollTop = min(this.max_top, this.scrollTop + offset);
    }
     
    var v = new View(this.divToScroll);   
    v.set_top(this.clipTop - this.scrollPos);
    v.clip(this.scrollPos, v.width(), this.clipHeight + this.scrollPos, 0);
    this.scrollThumb.set_top(this.scrollTop);
    return (this.scrollPos != this.min_pos && this.scrollPos != this.max_pos); 
}

function scroller() 
{
    this.init = scrollerInit;
    this.setDivToScroll = scrollerSetDivToScroll;
    this.scroll_to = scrollerScrollTo;
    
    this.wheel_scroller = function()
    {
        var scroller = this;
        return function(e)
        {
            var accel;
            if(e.wheelDelta < 0)
                accel = max(-1,(e.wheelDelta/75));
            else
                accel = min(1,(e.wheelDelta/75));
                
            var scale = 11/scroller.scroll_per_pixel;
            var d;
            if(accel>0)
                d = Math.ceil(accel*scale);
            else
                d = Math.floor(accel*scale);
            scroller.scroll_to(-d);
        }
    }
    
    this.resized = function()
    {
        this.clipHeight = widgetView.height() - 65 - 40;
        this.setDivToScroll(this.divToScroll);
    }
    
    this.stepSize = 2;
    this.clipHeight = 180;
    this.clipTop = 0;
    this.scrollSpeed = 20;
    this.scrollPos = 0;
    this.scrollTimer = 0;
    this.scrollTop = 73;
    this.scrollThumb = null;
    this.scroll_track = null;
    this.divToScroll = null;
    this.mouse_tracker = null;
    this.scroll_per_pixel = 1;
    this.max_pos = 100;
    this.min_pos = 0;
    this.max_top = 20;
}

function MouseTracker(e) 
{
    this.mouse_down_x = e.x || e.clientX;
    this.mouse_down_y = e.y || e.clientY;
    this.current_x = e.x || e.clientX;
    this.current_y = e.y || e.clientY;
	this.last_x = e.x || e.clientX;
	this.last_y = e.y || e.clientY;

	this.on_mouse_up = null;
	this.on_mouse_move = null;
    
    MouseTracker.prototype.offset_x = function()
    {
        return this.current_x - this.mouse_down_x;
    }
    
    MouseTracker.prototype.offset_y = function()
    {
        return this.current_y - this.mouse_down_y;
    }
 
	MouseTracker.prototype.delta_x = function()
	{
		return this.current_x - this.last_x;
	}
	
	MouseTracker.prototype.delta_y = function()
	{
		return this.current_y - this.last_y;
	}
	
	var tracker = this;
	
	function tracker_mouse_move(e)
	{
		tracker.last_x = tracker.current_x;
		tracker.last_y = tracker.current_y;
        tracker.current_x = e.x || e.clientX;
        tracker.current_y = e.y || e.clientY;
		if(tracker.on_mouse_move)
			tracker.on_mouse_move(tracker);
		e.stopPropagation();
	}
	
	function tracker_mouse_up(e)
	{
		document.removeEventListener("mousemove", tracker_mouse_move, true);
		document.removeEventListener("mouseup", tracker_mouse_up, true);
		if(tracker.on_mouse_up)
			tracker.on_mouse_up(tracker);
		tracker = null;
		e.stopPropagation();
	}
	
   	document.addEventListener("mousemove", tracker_mouse_move, true);
    document.addEventListener("mouseup", tracker_mouse_up, true);
}

function ScrollThumbTracker(scroller) 
{
    this.scroller = scroller;

    mouse_up = function(tracker)
    {
        var div = dom("wikit-area");
        div.style["-khtml-user-select"] = "text";
        div.style["-khtml-user-modify"] = "read";
    }
    
    mouse_move = function(tracker)
    {
        if(!scroller) {alert("null scroller"); return;}
        scroller.scroll_to(tracker.delta_y());
    }
    
    ScrollThumbTracker.prototype.start_tracking = function(e)
    {
		var tracker = new MouseTracker(e);

		tracker.on_mouse_move = mouse_move;
		tracker.on_mouse_up = mouse_up;
        var div = dom("wikit-area");
        div.style["-khtml-user-select"] = "none";
        div.style["-khtml-user-modify"] = "none";
    }
    
}

function start_tracking_scroll(e) 
{
    wikiController.scroll_tracker.start_tracking(e)
}

function scroll_page_click(e) 
{
    var n = e.y - wikiController.wikitScroller.scrollTop;
    var x = wikiController.wikitScroller.scroll_per_pixel;
    if(n<0)
        n = (1/x)*-wikiController.wikitScroller.clipHeight;
    else
        n = (1/x)*wikiController.wikitScroller.clipHeight;
        
    wikiController.wikitScroller.scroll_to(n);
}

function ToolbarButton(div) 
{
    this.action = div.onclick;
    this.div = div;
    this.enabled = true;
    this.enabled_style = "toolbar-button";
    this.disabled_style = "disabled-toolbar-button";
    
    ToolbarButton.prototype.set_action = function(action)
    {
        this.action = action;
        if(this.enabled)
        {
            this.div.onclick = action;
        }
    }
    
    ToolbarButton.prototype.enable = function()
    {
        this.div.setAttribute("class", this.enabled_style);
        this.div.onclick = this.action;
        this.enabled = true;
    }
    
    ToolbarButton.prototype.disable = function()
    {
        this.div.setAttribute("class", this.disabled_style);
        this.div.onclick = null;
        this.enabled = false;
    }
    
    ToolbarButton.prototype.id = function()
    {
        return this.div.getAttribute('id');
    }
    
}

function Toolbar() 
{
    this.buttons = [];
    this.enabled_buttons = [];
    
    Toolbar.prototype.scan_for_buttons = function()
    {
        var tb = this;
        var divs = widgetView.div.getElementsByTagName('div');
        for_each(divs, function(div)
        {
            if('toolbar' != div.getAttribute('class'))
            {
                return;
            }
            var buttons = div.getElementsByTagName('a');
            for_each(buttons, function(button)
            {
                if('toolbar-button' != button.getAttribute('class'))
                {
                    return;
                }
               tb.button_with_id(button.getAttribute('id'));
            });
        });
    }
    
    Toolbar.prototype.button_with_id = function(id)
    {
        if(this.buttons[id]) return this.buttons[id];
        var div = document.getElementById(id);
        if(!div)
        {
            log(id + " button does not exist");
            return null;
        }
        this.buttons[id] = new ToolbarButton(div);
        return this.buttons[id];
    }
    
    Toolbar.prototype.disable_browse = function()
    {
        this.button_with_id("browse-delete").disable();
        this.button_with_id("browse-home").disable();
        this.button_with_id("browse-edit").disable();
        this.button_with_id("browse-new").disable();
    }
    
    Toolbar.prototype.disable_edit = function()
    {
        this.button_with_id("edit-delete").disable();
        this.button_with_id("edit-home").disable();
        this.button_with_id("edit-cancel").disable();
        this.button_with_id("edit-save").disable();
    }
    
    Toolbar.prototype.disable_all = function()
    {   
        this.disable_browse();
        this.disable_edit();
        document.getElementById('search-field').disabled = true;
    }
    
    Toolbar.prototype.enable_browse = function()
    {
        this.button_with_id("browse-delete").enable();
        this.button_with_id("browse-home").enable();
        this.button_with_id("browse-edit").enable();
        this.button_with_id("browse-new").enable();
    }
    
    Toolbar.prototype.enable_edit = function()
    {
        this.button_with_id("edit-delete").enable();
        this.button_with_id("edit-home").enable();
        this.button_with_id("edit-cancel").enable();
        this.button_with_id("edit-save").enable();
    }
    
    Toolbar.prototype.enable_all = function()
    {
        this.enable_browse();
        this.enable_edit();
        document.getElementById('search-field').disabled = false;
    }
    
    Toolbar.prototype.blur = function()
    {
        var tb = this;
        this.enabled_buttons = [];
        for_each(this.buttons, 
                 function(button) 
                 {
                    tb.enabled_buttons[button.id()] = button;
                    button.disable();
                 });
        document.getElementById('search-field').disabled = true;
    }
    
    Toolbar.prototype.focus = function()
    {
        for_each(this.enabled_buttons,
                 function(button)
                 {
                     button.enable();
                 });
        document.getElementById('search-field').disabled = false;
    }

}

window.onfocus = function() 
{
    toolbar.focus();
    document.getElementById('search-field').disabled = false;
}

window.onblur = function() 
{
    toolbar.blur();
    
}

var toolbar = new Toolbar();

function Throbber(div, start, end) 
{
    this.start = start;
    this.end = end;
    this.div = div;
    
}

/*! @functiongroup Fader */

/*! 
    @function Fader 
        Fades a div from one opactity to level to another
    @param div 
        The DOM element to fade
    @param start 
        The starting opacity: 0 <= start <= 1
    @param end 
        The ending opacity: 0 <= end <= 1
    @param time 
        The total time in seconds for the animation
    @param action 
        A function to call when the animation is done
        can be null
*/

function Fader(div, start, end, time, action) 
{
    this.start = start;
    this.end = end;
    this.div = div;
    this.action = action;
    this.opacity = this.start;
    this.div.style.opacity = this.opacity;
    this.interval_id = 0;
    
    Fader.prototype.fade_step = function()
    {
        
        var fader = this;
        return function()
        {
            fader.opacity += (25*(fader.end - fader.start))/time;
            var o = fader.opacity;
            var div = fader.div;
            var stop = false;
            if( fader.end < fader.start )
            {
                stop = fader.end >= (o - .001);
            }
            else
            {
                stop = fader.end <= (o + .001); 
            }
            var id = fader.interval_id;
            div.style.opacity = o;
            if(stop)
            {
                clearInterval(id);
                if(fader.action) fader.action();
                fader = null;
            }
        }
    }
    
    this.interval_id = setInterval(this.fade_step(), time/25);
}

function Sheet(id, message) 
{
    this.message = message;
    this.has_button = false;
    var div = document.createElement("div");
    div.setAttribute("id", id);
    div.setAttribute("class", "sheet");
    var msg = document.createElement("p");
    msg.appendChild(document.createTextNode(message));
    div.appendChild(msg);
    this.id = id;
	var sv = new View(div);
    this.view = widgetView.add_subview(sv);
    this.view.set_width(widgetView.width() - 
                        this.view.margin('left') - 
                        this.view.margin('right'));
    this.keypress_handler = null;
    this.keymap = [];    
    
    Sheet.prototype.create_close_handler = function(obj)
    {
        
        return function(){ obj.close(); }
    }
    
    Sheet.prototype.add_button = function(name, handler, char_code)
    {
        var buttons = document.getElementById("button-list-" + this.id);
        if( !buttons )
        {
            buttons = document.createElement("ul");
            buttons.setAttribute("id", "button-list-" + this.id );
            this.view.div.appendChild(buttons);
        }
        
        var button = document.createElement("li");
        var link = document.createElement("a");
        link.onclick = handler;
        link.href = "#"
        link.appendChild(document.createTextNode(name));
        button.appendChild(link);
        buttons.appendChild(button);
        this.has_button = true;
        if(char_code) this.keymap[char_code] = handler;
    }
    
    Sheet.prototype.create_key_handler = function()
    {
        var keymap = this.keymap;
        return function(e)
        {
            if(keymap[e.charCode]) 
            {
                keymap[e.charCode]();
                e.stopPropagation();
                e.preventDefault();
            }
        }
    }
    
    Sheet.prototype.show = function()
    {
        if(!this.has_button)
        {
            this.add_button("OK", this.create_close_handler(this), 13);
        }
        this.view.show();
        var base_time = 250;
        if(null != window.event)
			if (window.event.shiftKey) base_time *= 4;
        var f = new Fader(this.view.div, 0, 0.95, base_time, null);
        this.keypress_handler = this.create_key_handler();
        document.addEventListener("keypress", this.keypress_handler, true);
    }
    
    Sheet.prototype.create_deleter = function()
    {
        var v = this.view;
        return function()
        {
			v.hide();
            v.div.parentNode.removeChild(v.div);
        }
    }
    
    Sheet.prototype.close = function()
    {
        document.removeEventListener("keypress", this.keypress_handler, true);
        var base_time = 250;
        if(null != window.event)
			if(window.event.shiftKey) base_time *= 4;
        var f = new Fader(this.view.div, 
                          0.95, 
                          0, 
                          base_time, 
                          this.create_deleter());
    }
    
}

document.addEventListener("keypress", key_pressed, true);

function handle_command_key(e, char_code) 
{
    var key = String.fromCharCode(char_code);
    if(key == "n" && 
        toolbar.button_with_id("browse-new").enabled)
    {
        wikiNew();
        return true;
    }
    else if(key == "h" && 
            toolbar.button_with_id("browse-home").enabled)
    {
        wikiHome();
        return true;
    }
    else if(key == "e" && 
            toolbar.button_with_id("browse-edit").enabled)
    {
        wikiEdit();
        return true;
    }
    else if(key == "s" && 
            toolbar.button_with_id("edit-save").enabled)
    {
        wikiSave();
        return true;
    }
    else if(key == "f")
    {
        document.getElementById("search-field").focus();
        return true;
    }
    else if(27 == char_code && 
            toolbar.button_with_id("edit-cancel").enabled &&
            wikiController.isEditing()) //esc
    {
        wikiCancel();
        return true;
    }
    else if(8 == char_code && 
            toolbar.button_with_id("browse-delete").enabled) //delete
    {
        wikiDelete();
        return true;
    }   
    else if(key == "=" && e.shiftKey)
    {
        wikiController.make_text_larger();
        return true;
    }
    else if(key == "-")
    {
        wikiController.make_text_smaller();
        return true;
    }
    else if("[" == key)
    {
        goback = function()
        {
            wikity_history.go_back();
        }
        if(wikiController.isEditing())
            wikiCancel(goback);
        else
            goback();
        return true;
    }
    else if("]" == key)
    {
        gofwd = function()
        {
            wikity_history.go_forward();
        }
        if(wikiController.isEditing())
            wikiCancel(gofwd);
        else
            gofwd();
        return true;
    }
    return false;
    
}

function key_pressed(e) 
{
    
    var handled = false;    
    switch (e.charCode)
    {
        case 63232: // up
            handled = false;
            break;
            
        case 63233: // down
            handled = false;
            break;
            
        default:
            if(e.metaKey)
                handled = handle_command_key(e, e.charCode);
            break;
    }
    
    if (handled)
    {
        e.stopPropagation();
        e.preventDefault();
    }
}

function event_handlers() 
{
    this.handlers = [];
}

//! A wrapper for DOM elements
//! 
function View(div, name) 
{ 
   	this.div = div;
	this.style = div.style;
    this.name = name;
    this.subviews = [];

	View.prototype.computedStyle = function()
	{
	    return document.defaultView.getComputedStyle(this.div, '');
	}

	View.prototype.computedInt = function(prop)
	{
	    return parseInt(this.computedStyle().getPropertyValue(prop));
	}

	View.prototype.width = function()
	{
	    return this.computedInt('width');
	}

	View.prototype.height = function()
	{
	    return this.computedInt('height');
	}

	View.prototype.top = function()
	{
	    return this.computedInt('top');
	}

	View.prototype.left = function()
	{
	    return this.computedInt('left');
	}

	View.prototype.set_top = function(t)
	{
	    this.div.style.top = t + "px";
	}

	View.prototype.set_left = function(l)
	{
	    this.div.style.left = l + "px";
	}

	View.prototype.set_height = function(h)
	{
	    this.div.style.height = h + "px"; 
	}

	View.prototype.set_width = function(w)
	{
	    this.div.style.width = w + "px";
	}

	View.prototype.set_bottom = function(b)
	{
	    this.div.style.bottom = b + "px";
	}

	View.prototype.add_subview = function(sub, name)
	{
	    this.subviews[name] = new View(this.div.appendChild(sub.div));
	    return this.subviews[name];
	}

	View.prototype.hide = function()
	{
	    if( !this.div ) log( "hideElement: div is null" );
	    this.div.style.visibility = "hidden";
	}

	View.prototype.show = function()
	{
	    if( !this.div ) log( "hideElement: div is null" );
	    this.div.style.visibility = "visible";
	}

	View.prototype.clip = function(top, right, bottom, left) 
	{
	    this.div.style.clip = "rect(" + 
	                            top +"px " + 
	                            right + "px " + 
	                            bottom  +  "px " + 
	                            left + "px)";
	}

	View.prototype.margin = function(side)
	{
	    if(!side) 
	    {
	        return this.computedInt("margin");
	    }
	    else 
	    {
	        return this.computedInt("margin-" + side);
	    }
	}

	View.prototype.disable = function()
	{
	    this.div.disabled = true;
	}

	View.prototype.enable = function()
	{
	    this.div.disabled = false;
	}
    
    

}

/*! @functiongroup ScrollView */

/*!    
    @function ScrollView
        Constructs a scroll view.
    
    @discussion
        ScrollView isn't used anywhere yet, it's meant to replace
        the scroller class and inherit all the methods from View

        Construct a ScrollView
        The view will create and manage the scrollbars. Use css selectors
        to control the scrollbar appearance:

            .scroll_track

            .scroll_thumb

            #[view_name]-scroll_track

            #[view_name]-scroll_thumb
            
    @param div 
        A DOM element that the ScrollView will control
        this is *not* the contents of the ScrollView, it is
        the view that will contain the contents.

    @param name 
        See \ref View 

*/


function ScrollView(div, name) 
{
    this.prototype = new View(div, name);
    
    /*! 
        @function scroll_to
            Scroll the view to the given offset of the current scroll position
        @param offset 
            If negative, scroll up. If positive, scroll down.
    */
    this.scroll_to = function(offset)
    {
        if(!this.scrolled_div) return;
        var n = 0;
        if(offset < 0)
            n = Math.floor(offset*this.scroll_per_pixel);
        else
            n = Math.ceil(offset*this.scroll_per_pixel);
        if( offset < 0 )
        {
            this.scroll_pos = max(this.min_pos, this.scroll_pos + n);
            this.scroll_top = max(80, this.scroll_top + offset );
        }
        else
        {
            this.scroll_pos = min(this.max_pos, this.scroll_pos + n);
            this.scroll_top = min(this.max_top, this.scroll_top + offset);
        }

        this.scrolled_div.set_top(this.top() - this.scroll_pos);
        this.scrolled_div.clip(this.scroll_pos, 
                               this.width(), 
                               this.height() + this.scroll_pos, 
                               0);
        this.scroll_thumb.set_top(this.scroll_top);
        return (this.scroll_pos != this.min_pos && 
                this.scrol_pos != this.max_pos);
    }
    
    this.wheel_scroller = function()
    {
        var scroller = this;
        return function(e)
        {
            var accel;
            if(e.wheelDelta < 0)
                accel = max(-1,(e.wheelDelta/75));
            else
                accel = min(1,(e.wheelDelta/75));
                
            var scale = 11/scroller.scroll_per_pixel;
            var d;
            if(accel>0)
                d = Math.ceil(accel*scale);
            else
                d = Math.floor(accel*scale);
            scroller.scroll_to(-d);
        }
    }
    
    /*! 
        @function set_scrolled_view
        Set the content view to be scrolled

        @param view 
            the view will be clipped and scrolled according to the
            geometry of the scroll view.
    */
    this.set_scrolled_view = function(view)
    {
        this.scrolled_view = view;
        if( null == this.divToScroll )
        {
            this.scroll_thumb.hide();
            this.scroll_track.hide();
            return;
        }

        this.scrolled_view.style.position = "absolute";
        this.scrolled_view.set_top(this.top());
        this.scroll_pos = 0;
        this.scrolled_view.clip(0, this.width(), this.height(), 0);
        if ( this.height() >= this.scrolled_view.scrollHeight ) 
        {
            this.max_pos = 0;
            this.scroll_thumb.hide();
            this.scroll_track.hide();
        } 
        else 
        {
            this.scroll_thumb.show();

            var h2 = this.scrolled_view.scrollHeight;
            var h3 = this.height();
            var pages = h2/h3;
            var maxHeight = this.height() - 15;
            var thumbHeight = max(maxHeight/pages, 25);

            this.scroll_per_pixel = (h2 - h3)/(this.height() - thumbHeight);
            this.scroll_thumb.set_height(thumbHeight - 5);

            this.scroll_thumb.set_top(top);
            this.scroll_top = 0;
            this.max_pos = this.srolled_view.scrollHeight - this.top();
            this.min_pos = 0;
            this.max_top = this.top() - thumbHeight;
            this.scroll_track.hide();
            this.scroll_track.set_top(top);
            this.scroll_track.set_height(this.max_top + thumbHeight - 5);
        }
    }
    
    this.step_size = 2;
    this.scroll_speed = 20;
    this.scroll_pos = 0;
    this.scroll_timer = 0;
    
    var d = document.createElement('div');
    d.setAttribute('class', 'scroll_thumb');
    d.setAttribute('id', this.name + '_scroll_thumb');
    d.style.position = "absolute";
    var v = new View(d);
    this.scroll_thumb = this.add_subview(v, "scroll_thumb");
    
    this.scroll_track = null;
    d = document.createElement('div');
    d.setAttribute('class', 'scroll_track');
    d.setAttribute('id', this.name + '_scroll_track');
    d.style.position = "absolute";
    v = new View(d);
    this.scroll_track = this.add_subview(v, "scroll_track");
    
    this.scrolled_view = null;
    this.mouse_tracker = null;
    this.scroll_per_pixel = 1;
    this.max_pos = 100;
    this.min_pos = 0;
    this.max_top = 20;
}

function start_tracking_resize(event) 
{
    var resizer = new ViewResizer();
    resizer.start_tracking_resize(event);
}

function DOMView(id) 
{
	DOMView.prototype = View;
	
    var div = document.getElementById(id);
    if(null == div)
    {
        log("element with id: '" + id + "' doesn't exist.");
    }
    return new View(div);
}

function dom(id){ return new DOMView(id) };

function ViewResizer() 
{
	// to get this to work properly in a browser window, there should
	// max width and height properties so that you can't make resize
	// the widget larger than the browser window
    var start_height = widgetView.height();
    var start_width = widgetView.width();
    
    ViewResizer.prototype.resize = function(x,y)
    {
		widgetView.set_height(y);
		widgetView.set_width(x);
		
		// resizing the body doesn't work, you actually have to resize
		// the whole window in dashboard. not sure if that is a bug or
		// a feature. i'd call it a bug because it makes it much more
		// difficult to make the widget work in a web browser as well
		// as in dashboard
        if(window.widget) window.resizeTo(x, y);

        wikiController.wikitScroller.resized();
    }
    
	var this_resizer = this;
	
    resizer_mouse_move = function(tracker)
    {
        var x = tracker.offset_x() + start_width;
        
        if(x < 320)
        {
            x = 320;
        }
        
        var y = tracker.offset_y() + start_height;
        if( y < 270)
        {
            y = 270;
        }

        this_resizer.resize(x,y);
    }
    
    resizer_mouse_up = function(tracker)
    {
        var prefs = new Prefs(kDomainWidgetInstance);
        prefs.set('width', window.innerWidth);
        prefs.set('height', window.innerHeight);

        var div = dom("wikit-area");
        div.style["-khtml-user-select"] = "text";
        div.style["-khtml-user-modify"] = "read";
		this_resizer = null;
    }
    
    ViewResizer.prototype.start_tracking_resize = function(event)
    {
        var tracker = new MouseTracker(event);
		tracker.on_mouse_move = resizer_mouse_move;
		tracker.on_mouse_up = resizer_mouse_up;
        var div = dom("wikit-area");
        div.style["-khtml-user-select"] = "none";
        div.style["-khtml-user-modify"] = "none";
    }
    
}

var wikity_history = new ActionHistory();

function ActionHistory() 
{
    
    function HistoryItem(identifier, action)
    {
        this.id = identifier;
        this.action = action;
    }
    
    this.navigation_history = new Array();
    this.current = -1;
    
    this.dump = function()
    {
        log("history dump:");
        for(var ii = 0; ii < this.navigation_history.length; ++ii)
        {
            log(this.navigation_history[ii].id);
        }
    }
    
    this.add = function(identifier, action)
    {
        var hi = new HistoryItem(identifier, action);
        for(var ii = 0; ii < this.navigation_history.length; ++ii)
        {
            if(this.navigation_history[ii].id == hi.id &&
                this.current == ii)
            {
                return;
            }
            else if(this.navigation_history[ii].id == hi.id)
            {
                this.navigation_history.splice(ii--, 1);
                this.current = -1;
                this.navigation_history.push(hi);
                return;
            }
        }
        if(-1 != this.current)
        {
            var nn = this.navigation_history.length - this.current - 1;
            this.navigation_history.splice(this.current + 1, nn);
        }
        this.current = -1;
        this.navigation_history.push(hi);
    }
    
    this.go_back = function()
    {
        if(!this.can_go_back()) return;
        
        if(-1 == this.current) 
			this.current = this.navigation_history.length - 2;
        else this.current--;
        this.navigation_history[this.current].action();
    }
    
    this.go_forward = function()
    {
       if(!this.can_go_forward()) return;
       
       this.current++;
       this.navigation_history[this.current].action();
       if(this.current == (this.navigation_history.length-1)) 
			this.current = -1;
    }
    
    this.can_go_forward = function()
    {
         return (-1 != this.current);
    }
    
    this.can_go_back = function()
    {
        return (this.navigation_history.length > 1 && 
                0 != this.current);
    }

}

var kDomainWidgetInstance = "inkling." + ((window.widget) ? widget.identifer :
                                                           "browser");

function Prefs(domain) 
{
    
    function make_key(key) 
    {
        if(domain) return domain + "." + key;
        else return key;
    }
    
    Prefs.prototype.set = function(key, value)
    {
        if(!window.widget) return;
        return widget.setPreferenceForKey(value, make_key(key));
    }
    
    Prefs.prototype.get = function(key)
    {
		if(!window.widget) return;
        return widget.preferenceForKey(make_key(key));
    }
}

function Button(div) 
{
    this.prototype = new View(div);
    
    this.action = null;
    
    Button.prototype.set_action = function(f)
    {
        this.action = f;
    }
    
    Button.prototype.enabled = function()
    {
        return f.enabled();
    }
}



/*
	the json code is from json.org
*/


/*
    json.js
    2006-09-27

    This file adds these methods to JavaScript:

        object.toJSONString()

            This method produces a JSON text from an object. The
            object must not contain any cyclical references.

        array.toJSONString()

            This method produces a JSON text from an array. The
            array must not contain any cyclical references.

        string.parseJSON()

            This method parses a JSON text to produce an object or
            array. It will return false if there is an error.

    It is expected that these methods will formally become part of the
    JavaScript Programming Language in the Fourth Edition of the
    ECMAScript standard.
*/
(function () {
    var m = {
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        s = {
            array: function (x) {
                var a = ['['], b, f, i, l = x.length, v;
                for (i = 0; i < l; i += 1) {
                    v = x[i];
                    f = s[typeof v];
                    if (f) {
                        v = f(v);
                        if (typeof v == 'string') {
                            if (b) {
                                a[a.length] = ',';
                            }
                            a[a.length] = v;
                            b = true;
                        }
                    }
                }
                a[a.length] = ']';
                return a.join('');
            },
            'boolean': function (x) {
                return String(x);
            },
            'null': function (x) {
                return "null";
            },
            number: function (x) {
                return isFinite(x) ? String(x) : 'null';
            },
            object: function (x) {
                if (x) {
                    if (x instanceof Array) {
                        return s.array(x);
                    }
                    var a = ['{'], b, f, i, v;
                    for (i in x) {
                        v = x[i];
                        f = s[typeof v];
                        if (f) {
                            v = f(v);
                            if (typeof v == 'string') {
                                if (b) {
                                    a[a.length] = ',';
                                }
                                a.push(s.string(i), ':', v);
                                b = true;
                            }
                        }
                    }
                    a[a.length] = '}';
                    return a.join('');
                }
                return 'null';
            },
            string: function (x) {
                if (/["\\\x00-\x1f]/.test(x)) {
                    x = x.replace(/([\x00-\x1f\\"])/g, function(a, b) {
                        var c = m[b];
                        if (c) {
                            return c;
                        }
                        c = b.charCodeAt();
                        return '\\u00' +
                            Math.floor(c / 16).toString(16) +
                            (c % 16).toString(16);
                    });
                }
                return '"' + x + '"';
            }
        };

    Object.prototype.toJSONString = function () {
        return s.object(this);
    };

    Array.prototype.toJSONString = function () {
        return s.array(this);
    };
})();

String.prototype.parseJSON = function () {
    try {
        return !(/[^,:{}\[\]0-9.\-+Eaeflnr-u \n\r\t]/.test(
                this.replace(/"(\\.|[^"\\])*?"/g, ''))) &&
            eval('(' + this + ')');
    } catch (e) {
        return false;
    }
};


/*
	below cookie code is from quirksmode.org
	http://www.quirksmode.org/js/cookies.html
*/
function createCookie(name,value,days) 
{
	if (days) 
	{
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";
	document.cookie = name+"="+escape(value)+expires+"; path=/";
}

function readCookie(name) 
{
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) 
	{
		var c = ca[i];
		while (c.charAt(0)==' ') 
			c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) 
			return unescape(c.substring(nameEQ.length,c.length));
	}
	return null;
}

function eraseCookie(name) 
{
	createCookie(name,"",-1);
}